# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.obatch_inst_all_children_completed import oBatchInstAllChildrenCompleted

class dBatchInstAllChildrenCompleted:
    __slots__ = ("_dbcon", "_dbstmnt", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.orec     = oBatchInstAllChildrenCompleted()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec(self) -> "dBatchInstAllChildrenCompleted":
        """
        Execute the query.

        :return: Self for convenience.
        """
        self._destroy()

        self._dbstmnt = self._dbcon.statement("BatchInstAllChildrenCompleted", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  bi.id
from
  monitor.batchinst bi
where
  bi.status = 'B'
except select
  i.id
from
  monitor.batchinst i
    join
  monitor.jobinst j
    on j.batchinst_id = i.id
where
  i.status  = 'B'  and
  j.status NOT IN ('C', 'O')
group by
  i.id""")

        self._dbstmnt.bind_out("id", int, 8)

        self._dbcon.execute(self._dbstmnt)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:BatchInst, proc:AllChildrenCompleted]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.id = self._dbstmnt.result[0]

        return True

    def fetch_all(self, out_list: oBatchInstAllChildrenCompleted.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

