# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_inst_not_completed import iBatchInstNotCompleted
from bs_monitor.db.tables.batch_inst import tBatchInst

class dBatchInstNotCompleted:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchInstNotCompleted()
        self.orec     = tBatchInst()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  batch_id: int,
                  sys_date: datetime.datetime) -> "dBatchInstNotCompleted":
        """
        Execute the query by setting all the inputs.

        :param batch_id: int
        :param sys_date: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.batch_id = batch_id
        self.irec.sys_date = sys_date

        return self.exec()

    def exec(self, irec: iBatchInstNotCompleted = None) -> "dBatchInstNotCompleted":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("BatchInstNotCompleted", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  *
from
  monitor.batchinst
where
  batch_id    = :batchId and
  run_date   <= :sysDate and
  end_date is null""")

        self._dbstmnt.bind_in("batchId", self.irec.batch_id, int, 8)
        self._dbstmnt.bind_in("sysDate", self.irec.sys_date, datetime.datetime)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("parent_id", int, 8)
        self._dbstmnt.bind_out("batch_id", int, 8)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("run_date", datetime.datetime)
        self._dbstmnt.bind_out("start_date", datetime.datetime)
        self._dbstmnt.bind_out("end_date", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:BatchInst, proc:NotCompleted, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.parent_id = self._dbstmnt.result[1]
        self.orec.batch_id = self._dbstmnt.result[2]
        self.orec.status = self._dbstmnt.result[3]
        self.orec.run_date = self._dbstmnt.result[4]
        self.orec.start_date = self._dbstmnt.result[5]
        self.orec.end_date = self._dbstmnt.result[6]

        return True

    def fetch_all(self, out_list: tBatchInst.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

