# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.batch_item import tBatchItem

class dBatchItemUpdate:
    __slots__ = ("_dbcon", "_dbstmnt", "irec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tBatchItem()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  id: int,
                  batch_id: int,
                  job_id: int,
                  extra_args: str,
                  stamp_by: str) -> "dBatchItemUpdate":
        """
        Execute the query by setting all the inputs.

        :param id: int
        :param batch_id: int
        :param job_id: int
        :param extra_args: str
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.id = id
        self.irec.batch_id = batch_id
        self.irec.job_id = job_id
        self.irec.extra_args = extra_args
        self.irec.stamp_by = stamp_by

        return self.exec()

    def exec(self, irec: tBatchItem = None) -> "dBatchItemUpdate":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("BatchItemUpdate", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""update
  monitor.BatchItem
set
  job_id = :job_id,
  extra_args = :extra_args,
  stamp_by = :stamp_by,
  stamp_tm = :stamp_tm
where
  id = :id and
  batch_id = :batch_id""")

        self.irec.stamp_tm = self._dbcon.get_timestamp()

        self._dbstmnt.bind_in("id", self.irec.id, int, 8)
        self._dbstmnt.bind_in("batch_id", self.irec.batch_id, int, 8)
        self._dbstmnt.bind_in("job_id", self.irec.job_id, int, 8)
        self._dbstmnt.bind_in("extra_args", self.irec.extra_args, str, 128)
        self._dbstmnt.bind_in("stamp_by", self.irec.stamp_by, str, 128)
        self._dbstmnt.bind_in("stamp_tm", self.irec.stamp_tm, datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

