# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ijob_inst_by_status_name_and_date import iJobInstByStatusNameAndDate
from bs_monitor.db.tables.job_inst import tJobInst

class dJobInstByStatusNameAndDate:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iJobInstByStatusNameAndDate()
        self.orec     = tJobInst()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  process_date: datetime.datetime,
                  name: str,
                  status: str) -> "dJobInstByStatusNameAndDate":
        """
        Execute the query by setting all the inputs.

        :param process_date: datetime.datetime
        :param name: str
        :param status: str
        :return: Self for convenience.
        """
        self.irec.process_date = process_date
        self.irec.name = name
        self.irec.status = status

        return self.exec()

    def exec(self, irec: iJobInstByStatusNameAndDate = None) -> "dJobInstByStatusNameAndDate":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobInstByStatusNameAndDate", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  i.*
from
  monitor.jobinst i,
  monitor.job     j
where
  j.name          = :name   and
  i.job_id        = j.id    and
  i.status        = :status and
  i.process_date <= :processDate
order by
  i.process_date""")

        self._dbstmnt.bind_in("processDate", self.irec.process_date, datetime.datetime)
        self._dbstmnt.bind_in("name", self.irec.name, str)
        self._dbstmnt.bind_in("status", self.irec.status, str, 1)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("parent_id", int, 8)
        self._dbstmnt.bind_out("job_id", int, 8)
        self._dbstmnt.bind_out("batchinst_id", int, 8)
        self._dbstmnt.bind_out("process_date", datetime.datetime)
        self._dbstmnt.bind_out("priority", int, 4)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("extra_args", str, 256)
        self._dbstmnt.bind_out("group_job", str, 128)
        self._dbstmnt.bind_out("group_batch", str, 128)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:JobInst, proc:ByStatusNameAndDate, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.parent_id = self._dbstmnt.result[1]
        self.orec.job_id = self._dbstmnt.result[2]
        self.orec.batchinst_id = self._dbstmnt.result[3]
        self.orec.process_date = self._dbstmnt.result[4]
        self.orec.priority = self._dbstmnt.result[5]
        self.orec.status = self._dbstmnt.result[6]
        self.orec.extra_args = self._dbstmnt.result[7]
        self.orec.group_job = self._dbstmnt.result[8]
        self.orec.group_batch = self._dbstmnt.result[9]
        self.orec.stamp_by = self._dbstmnt.result[10]
        self.orec.stamp_tm = self._dbstmnt.result[11]

        return True

    def fetch_all(self, out_list: tJobInst.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

