# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ijob_inst_cancel_purge import iJobInstCancelPurge
from bs_monitor.db.tables.job_inst_cancel import tJobInstCancel

class dJobInstCancelPurge:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iJobInstCancelPurge()
        self.orec     = tJobInstCancel()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  value_date: datetime.date) -> "dJobInstCancelPurge":
        """
        Execute the query by setting all the inputs.

        :param value_date: datetime.date
        :return: Self for convenience.
        """
        self.irec.value_date = value_date

        return self.exec()

    def exec(self, irec: iJobInstCancelPurge = None) -> "dJobInstCancelPurge":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobInstCancelPurge", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""delete from
   monitor.jobinstcancel
where
   cast(stamp_tm as date) < :valueDate""")

        self._dbstmnt.bind_in("valueDate", self.irec.value_date, datetime.date)

        self._dbstmnt.bind_out("jobinst_id", int, 8)
        self._dbstmnt.bind_out("reason", str)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:JobInstCancel, proc:Purge, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.jobinst_id = self._dbstmnt.result[0]
        self.orec.reason = self._dbstmnt.result[1]
        self.orec.stamp_by = self._dbstmnt.result[2]
        self.orec.stamp_tm = self._dbstmnt.result[3]

        return True

    def fetch_all(self, out_list: tJobInstCancel.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

