# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.job_inst_cancel import tJobInstCancel

class dJobInstCancelSelectAll:
    __slots__ = ("_dbcon", "_dbstmnt", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.orec     = tJobInstCancel()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec(self) -> "dJobInstCancelSelectAll":
        """
        Execute the query.

        :return: Self for convenience.
        """
        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobInstCancelSelectAll", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  jobinst_id,
  reason,
  stamp_by,
  stamp_tm
from
  monitor.JobInstCancel
order by
  jobinst_id""")

        self._dbstmnt.bind_out("jobinst_id", int, 8)
        self._dbstmnt.bind_out("reason", str)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:JobInstCancel, proc:SelectAll]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.jobinst_id = self._dbstmnt.result[0]
        self.orec.reason = self._dbstmnt.result[1]
        self.orec.stamp_by = self._dbstmnt.result[2]
        self.orec.stamp_tm = self._dbstmnt.result[3]

        return True

    def fetch_all(self, out_list: tJobInstCancel.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

