# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ijob_inst_purge import iJobInstPurge

class dJobInstPurge:
    __slots__ = ("_dbcon", "_dbstmnt", "irec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iJobInstPurge()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  value_date: datetime.date) -> "dJobInstPurge":
        """
        Execute the query by setting all the inputs.

        :param value_date: datetime.date
        :return: Self for convenience.
        """
        self.irec.value_date = value_date

        return self.exec()

    def exec(self, irec: iJobInstPurge = None) -> "dJobInstPurge":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobInstPurge", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""delete from
  monitor.jobinst
where
  cast(process_date as date) < :valueDate""")

        self._dbstmnt.bind_in("valueDate", self.irec.value_date, datetime.date)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

