# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.job_inst import tJobInst

class dJobInstUpdate:
    __slots__ = ("_dbcon", "_dbstmnt", "irec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tJobInst()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  id: int,
                  parent_id: int,
                  job_id: int,
                  batchinst_id: int,
                  process_date: datetime.datetime,
                  priority: int,
                  status: str,
                  extra_args: str,
                  group_job: str,
                  group_batch: str,
                  stamp_by: str) -> "dJobInstUpdate":
        """
        Execute the query by setting all the inputs.

        :param id: int
        :param parent_id: int
        :param job_id: int
        :param batchinst_id: int
        :param process_date: datetime.datetime
        :param priority: int
        :param status: str
        :param extra_args: str
        :param group_job: str
        :param group_batch: str
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.id = id
        self.irec.parent_id = parent_id
        self.irec.job_id = job_id
        self.irec.batchinst_id = batchinst_id
        self.irec.process_date = process_date
        self.irec.priority = priority
        self.irec.status = status
        self.irec.extra_args = extra_args
        self.irec.group_job = group_job
        self.irec.group_batch = group_batch
        self.irec.stamp_by = stamp_by

        return self.exec()

    def exec(self, irec: tJobInst = None) -> "dJobInstUpdate":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobInstUpdate", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""update
  monitor.JobInst
set
  parent_id = :parent_id,
  job_id = :job_id,
  batchinst_id = :batchinst_id,
  process_date = :process_date,
  priority = :priority,
  status = :status,
  extra_args = :extra_args,
  group_job = :group_job,
  group_batch = :group_batch,
  stamp_by = :stamp_by,
  stamp_tm = :stamp_tm
where
  id = :id""")

        self.irec.stamp_tm = self._dbcon.get_timestamp()

        self._dbstmnt.bind_in("id", self.irec.id, int, 8)
        self._dbstmnt.bind_in("parent_id", self.irec.parent_id, int, 8)
        self._dbstmnt.bind_in("job_id", self.irec.job_id, int, 8)
        self._dbstmnt.bind_in("batchinst_id", self.irec.batchinst_id, int, 8)
        self._dbstmnt.bind_in("process_date", self.irec.process_date, datetime.datetime)
        self._dbstmnt.bind_in("priority", self.irec.priority, int, 4)
        self._dbstmnt.bind_in("status", self.irec.status, str, 1)
        self._dbstmnt.bind_in("extra_args", self.irec.extra_args, str, 256)
        self._dbstmnt.bind_in("group_job", self.irec.group_job, str, 128)
        self._dbstmnt.bind_in("group_batch", self.irec.group_batch, str, 128)
        self._dbstmnt.bind_in("stamp_by", self.irec.stamp_by, str, 128)
        self._dbstmnt.bind_in("stamp_tm", self.irec.stamp_tm, datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

