# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ijob_search import iJobSearch
from bs_monitor.db.tables.job import tJob

class dJobSearch:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iJobSearch()
        self.orec     = tJob()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  criteria: str,
                  limoff: str) -> "dJobSearch":
        """
        Execute the query by setting all the inputs.

        :param criteria: str
        :param limoff: str
        :return: Self for convenience.
        """
        self.irec.criteria = criteria
        self.irec.limoff = limoff

        return self.exec()

    def exec(self, irec: iJobSearch = None) -> "dJobSearch":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobSearch", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  j.*
from
  monitor.job j
where
  (1=1)
  [criteria]
order by
  j.name
[limoff]""")

        self._dbstmnt.dynamic("[criteria]", self.irec.criteria)
        self._dbstmnt.dynamic("[limoff]", self.irec.limoff)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("name", str, 256)
        self._dbstmnt.bind_out("group_id", str, 128)
        self._dbstmnt.bind_out("program_path", str, 256)
        self._dbstmnt.bind_out("program_args", str, 256)
        self._dbstmnt.bind_out("priority", int, 4)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:Job, proc:Search, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.name = self._dbstmnt.result[1]
        self.orec.group_id = self._dbstmnt.result[2]
        self.orec.program_path = self._dbstmnt.result[3]
        self.orec.program_args = self._dbstmnt.result[4]
        self.orec.priority = self._dbstmnt.result[5]
        self.orec.stamp_by = self._dbstmnt.result[6]
        self.orec.stamp_tm = self._dbstmnt.result[7]

        return True

    def fetch_all(self, out_list: tJob.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

