# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.job import tJob

class dJobUpdate:
    __slots__ = ("_dbcon", "_dbstmnt", "irec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tJob()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    def exec_deft(self,
                  id: int,
                  name: str,
                  group_id: str,
                  program_path: str,
                  program_args: str,
                  priority: int,
                  stamp_by: str) -> "dJobUpdate":
        """
        Execute the query by setting all the inputs.

        :param id: int
        :param name: str
        :param group_id: str
        :param program_path: str
        :param program_args: str
        :param priority: int
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.id = id
        self.irec.name = name
        self.irec.group_id = group_id
        self.irec.program_path = program_path
        self.irec.program_args = program_args
        self.irec.priority = priority
        self.irec.stamp_by = stamp_by

        return self.exec()

    def exec(self, irec: tJob = None) -> "dJobUpdate":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobUpdate", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""update
  monitor.Job
set
  name = :name,
  group_id = :group_id,
  program_path = :program_path,
  program_args = :program_args,
  priority = :priority,
  stamp_by = :stamp_by,
  stamp_tm = :stamp_tm
where
  id = :id""")

        self.irec.stamp_tm = self._dbcon.get_timestamp()

        self._dbstmnt.bind_in("id", self.irec.id, int, 8)
        self._dbstmnt.bind_in("name", self.irec.name, str, 256)
        self._dbstmnt.bind_in("group_id", self.irec.group_id, str, 128)
        self._dbstmnt.bind_in("program_path", self.irec.program_path, str, 256)
        self._dbstmnt.bind_in("program_args", self.irec.program_args, str, 256)
        self._dbstmnt.bind_in("priority", self.irec.priority, int, 4)
        self._dbstmnt.bind_in("stamp_by", self.irec.stamp_by, str, 128)
        self._dbstmnt.bind_in("stamp_tm", self.irec.stamp_tm, datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

