# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:20:59 2022
#  Target Database = postgresql
#
import asyncio
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.mondate import tMondate
from bs_monitor.db.tables.mondate_key import tMondateKey

from .mondate_select_one import dMondateSelectOne
from .mondate_update import dMondateUpdate
from .mondate_insert import dMondateInsert
from .mondate_delete_one import dMondateDeleteOne

class dMondate:
    __slots__ = ("_dbcon", "rec")

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self.rec    = tMondate()
        self._dbcon = dbcon

    def __enter__(self):
        """
        DAO enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        DAO exit.
        """
        pass

    def try_select_one(self) -> bool:
        """
        Attempt to select the record.

        :return: True if the record was found.
        """
        _key = tMondateKey()

        self.rec._write_key(_key)

        return self.try_select_one_by_key(_key)

    def try_select_one_with(self, _rec: tMondate) -> bool:
        """
        Attempt to select the record using a table rec.

        :param _rec: The table rec to select with and into.
        :return: True if the row as selectd.
        """
        _key = tMondateKey()
        _rec._write_key(_key)

        if not self.try_select_one_by_key(_key):
            return False

        _rec._copy_from(self.rec)

        return True

    def try_select_one_deft(self,
                            id: str) -> bool:
        """
        Attempt to select the record by it's primary key columns.

        :param id: str
        :return: True if the row as selectd.
        """
        _key = tMondateKey()

        _key.id = id

        return self.try_select_one_by_key(_key)

    def try_select_one_by_key(self, _key: tMondateKey) -> bool:
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :returns: True if row was selected.
        """
        with dMondateSelectOne(self._dbcon) as _qry:
            _qry.exec(_key)
            if not _qry.fetch():
                return False

            self.rec = _qry.orec

        return True

    def select_one(self) -> "dMondate":
        """
        Selects the record, raises and error if it does not exist.

        :return: Self for convenience.
        """
        if not self.try_select_one():
            raise mettle.lib.xMettle(f"Not found: [table:dMondate, row:{self.rec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)

        return self

    def select_one_with(self, _rec: tMondate) -> "dMondate":
        """
        Attempt to select the record with the table record.

        :param _rec: Table record.
        :returns: Self for convenience.
        """
        if not self.try_select_one_with(_rec):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dMondate)")

        return self

    def select_one_deft(self,
                        id: str) -> "dMondate":
        """
        Selects the record by its primary key columns, raises and error if it does not exist.

        :param id: str
        """
        _key = tMondateKey()

        _key.id = id

        if not self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle(f"Not found: [table:dMondate, row:{_key}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)

        return self

    def select_one_by_key(self, _key: tMondateKey) -> "dMondate":
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :return: Self for convenience.
        """
        if not self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle(f"Not found: [table:dMondate, row:{self.irec}]", xMettle.eCode.DBNotFound)

        return self

    def update_deft(self,
                    id: str,
                    descr: str,
                    value: datetime.date,
                    stamp_by: str):
        """
        Update the record by setting all column values.

        :param id: str
        :param descr: str
        :param value: datetime.date
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        """
        self.rec.id = id
        self.rec.descr = descr
        self.rec.value = value
        self.rec.stamp_by = stamp_by

        self.update()

    def update(self, irec: tMondate = None):
        """
        Update the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to update the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dMondateUpdate(self._dbcon) as _qry:
            _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

    def insert_deft(self,
                    id: str,
                    descr: str,
                    value: datetime.date,
                    stamp_by: str):
        """
        Insert the record setting all column values.

        :param id: str
        :param descr: str
        :param value: datetime.date
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        """
        self.rec.id = id
        self.rec.descr = descr
        self.rec.value = value
        self.rec.stamp_by = stamp_by

        self.insert()

    def insert(self, irec: tMondate = None):
        """
        Insert the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to insert into the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dMondateInsert(self._dbcon) as _qry:
            _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

    def delete_one_deft(self,
                        id: str):
        """
        Delete one record by it's primary key columns.

        :param id: str
        """
        _key = tMondateKey()

        _key.id = id

        self.delete_one(_key)

    def delete_one(self, irec: tMondateKey = None):
        """
        Delete the record by its primary key or irec if it is not None.

        :param irec: If not None use this record to delete record.
        """
        _key = tMondateKey()

        if irec:
            _key._copy_from(irec)
        else:
            self.rec._write_key(_key)

        with dMondateDeleteOne(self._dbcon) as _qry:
            _qry.exec(_key)

