# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:21:00 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_item_for_inserting import iBatchItemForInserting
from bs_monitor.db.tables.obatch_item_for_inserting import oBatchItemForInserting

class dBatchItemForInserting:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchItemForInserting()
        self.orec     = oBatchItemForInserting()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    async def exec_deft(self,
                        batch_id: int) -> "dBatchItemForInserting":
        """
        Execute the query by setting all the inputs.

        :param batch_id: int
        :return: Self for convenience.
        """
        self.irec.batch_id = batch_id

        return await self.exec()

    async def exec(self, irec: iBatchItemForInserting = None) -> "dBatchItemForInserting":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("BatchItemForInserting", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  i.job_id,
  i.extra_args,
  j.group_id,
  substring(j.name, 1, 32),
  j.priority
from
  monitor.batchitem i
    join
  monitor.job j
    on j.id = i.job_id
where
  i.batch_id = :batchId
order by
  i.id""")

        self._dbstmnt.bind_in("batchId", self.irec.batch_id, int, 8)

        self._dbstmnt.bind_out("jobId", int, 8)
        self._dbstmnt.bind_out("extraArgs", str, 128)
        self._dbstmnt.bind_out("groupJob", str, 128)
        self._dbstmnt.bind_out("groupBatch", str, 256)
        self._dbstmnt.bind_out("priority", int, 4)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:BatchItem, proc:ForInserting, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.job_id = self._dbstmnt.result[0]
        self.orec.extra_args = self._dbstmnt.result[1]
        self.orec.group_job = self._dbstmnt.result[2]
        self.orec.group_batch = self._dbstmnt.result[3]
        self.orec.priority = self._dbstmnt.result[4]

        return True

    async def fetch_all(self, out_list: oBatchItemForInserting.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while await self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

