# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:21:00 2022
#  Target Database = postgresql
#
import asyncio
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.job_inst_cancel import tJobInstCancel
from bs_monitor.db.tables.job_inst_cancel_key import tJobInstCancelKey

from .job_inst_cancel_lock_one import dJobInstCancelLockOne
from .job_inst_cancel_select_one import dJobInstCancelSelectOne
from .job_inst_cancel_insert import dJobInstCancelInsert
from .job_inst_cancel_delete_one import dJobInstCancelDeleteOne

class dJobInstCancel:
    __slots__ = ("_dbcon", "rec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self.rec    = tJobInstCancel()
        self._dbcon = dbcon

    def __enter__(self):
        """
        DAO enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        DAO exit.
        """
        pass

    async def lock_one(self, _lock4update: mettle.db.DBLock, _expected: bool = True) -> bool:
        """
        Lock and select the record.

        :param _lock4update: The db lock object to use.
        :param _expected: If set to false, will not raise if record is not found.
        :return: True if selected, False if not found and _expected is set to False
        """
        _key = tJobInstCancelKey()

        self.rec._write_key(_key)

        return await self.lock_one_by_key(_key, _lock4update, _expected)

    async def lock_one_with(self, _rec: tJobInstCancel, _lock4update: mettle.db.DBLock, _expected: bool = True) -> bool:
        """
        Lock and select the record using a record.

        :param _rec: The table rec to select with and into.
        :param _lock4update: The db lock object to use.
        :param _expected: If set to false, will not raise if record is not found.
        :return: True if selected, False if not found and _expected is set to False
        """
        _key = tJobInstCancelKey()
        _rec._write_key(_key)

        await self.lock_one_by_key(_key, _lock4update, _expected)
        _rec._copy_from(self.rec)
        return True

    async def lock_one_deft(self,
                            jobinst_id: int,
                            _lock4update: mettle.db.DBLock,
                            _expected: bool = True) -> bool:
        """
        Attempt to lock and select the record by it's primary key columns.

        :param jobinst_id: int
        :param _lock4update:  The db lock object to use. 
        :param _expected: bool
        """
        _key = tJobInstCancelKey()

        _key.jobinst_id = jobinst_id

        return await self.lock_one_by_key(_key, _lock4update, _expected)

    async def lock_one_by_key(self, _key: tJobInstCancelKey, _lock4update: mettle.db.DBLock, _expected: bool = True) -> bool:
        """
        Attempt to lock and select the record with it's primary key.

        :param _key: Primary key of the table record.
        :param _lock4update: The db lock object to use.
        :param _expected: If set to false, will not raise if record is not found.
        :return: True if selected, False if not found and _expected is set to False
        """
        with dJobInstCancelLockOne(self._dbcon) as _qry:
            _dex = _lock4update.retrys - 1 if _lock4update.retrys > 0 else 0

            while _dex >= 0:
                try:
                    await _qry.exec(_key)
                    if not await _qry.fetch():
                        if not _expected:
                            return False

                        raise mettle.lib.xMettle(f"Lock not found: [table:dJobInstCancel, row:{_key}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)

                    break
                except mettle.lib.xMettle as _x:
                    if _x.get_error_code() != mettle.lib.xMettle.eCode.DBLockNoWaitFailed:
                        raise _x

                    if _dex == 0:
                        raise mettle.lib.xMettle("Could not lock JobInstCancel record after %d attempt(s) at %d mili second intervals!" % (
_lock4update.retrys, _lock4update.mili_seconds), err_code = mettle.lib.xMettle.eCode.DBLockNoWaitFailed)

                    if _lock4update.mili_seconds > 0:
                        await asyncio.sleep(_lock4update.mili_seconds * 0.001)
                _dex -= 1

            self.rec = _qry.orec

            return True

    async def try_select_one(self) -> bool:
        """
        Attempt to select the record.

        :return: True if the record was found.
        """
        _key = tJobInstCancelKey()

        self.rec._write_key(_key)

        return await self.try_select_one_by_key(_key)

    async def try_select_one_with(self, _rec: tJobInstCancel) -> bool:
        """
        Attempt to select the record using a table rec.

        :param _rec: The table rec to select with and into.
        :return: True if the row as selectd.
        """
        _key = tJobInstCancelKey()
        _rec._write_key(_key)

        if not await self.try_select_one_by_key(_key):
            return False

        _rec._copy_from(self.rec)

        return True

    async def try_select_one_deft(self,
                                  jobinst_id: int) -> bool:
        """
        Attempt to select the record by it's primary key columns.

        :param jobinst_id: int
        :return: True if the row as selectd.
        """
        _key = tJobInstCancelKey()

        _key.jobinst_id = jobinst_id

        return await self.try_select_one_by_key(_key)

    async def try_select_one_by_key(self, _key: tJobInstCancelKey) -> bool:
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :returns: True if row was selected.
        """
        with dJobInstCancelSelectOne(self._dbcon) as _qry:
            await _qry.exec(_key)
            if not await _qry.fetch():
                return False

            self.rec = _qry.orec

        return True

    async def select_one(self) -> "dJobInstCancel":
        """
        Selects the record, raises and error if it does not exist.

        :return: Self for convenience.
        """
        if not await self.try_select_one():
            raise mettle.lib.xMettle(f"Not found: [table:dJobInstCancel, row:{self.rec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)

        return self

    async def select_one_with(self, _rec: tJobInstCancel) -> "dJobInstCancel":
        """
        Attempt to select the record with the table record.

        :param _rec: Table record.
        :returns: Self for convenience.
        """
        if not await self.try_select_one_with(_rec):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dJobInstCancel)")

        return self

    async def select_one_deft(self,
                              jobinst_id: int) -> "dJobInstCancel":
        """
        Selects the record by its primary key columns, raises and error if it does not exist.

        :param jobinst_id: int
        """
        _key = tJobInstCancelKey()

        _key.jobinst_id = jobinst_id

        if not await self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle(f"Not found: [table:dJobInstCancel, row:{_key}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)

        return self

    async def select_one_by_key(self, _key: tJobInstCancelKey) -> "dJobInstCancel":
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :return: Self for convenience.
        """
        if not await self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle(f"Not found: [table:dJobInstCancel, row:{self.irec}]", xMettle.eCode.DBNotFound)

        return self

    async def insert_deft(self,
                          jobinst_id: int,
                          reason: str,
                          stamp_by: str):
        """
        Insert the record setting all column values.

        :param jobinst_id: int
        :param reason: str
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        """
        self.rec.jobinst_id = jobinst_id
        self.rec.reason = reason
        self.rec.stamp_by = stamp_by

        await self.insert()

    async def insert(self, irec: tJobInstCancel = None):
        """
        Insert the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to insert into the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dJobInstCancelInsert(self._dbcon) as _qry:
            await _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

    async def delete_one_deft(self,
                              jobinst_id: int):
        """
        Delete one record by it's primary key columns.

        :param jobinst_id: int
        """
        _key = tJobInstCancelKey()

        _key.jobinst_id = jobinst_id

        await self.delete_one(_key)

    async def delete_one(self, irec: tJobInstCancelKey = None):
        """
        Delete the record by its primary key or irec if it is not None.

        :param irec: If not None use this record to delete record.
        """
        _key = tJobInstCancelKey()

        if irec:
            _key._copy_from(irec)
        else:
            self.rec._write_key(_key)

        with dJobInstCancelDeleteOne(self._dbcon) as _qry:
            await _qry.exec(_key)

