# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:21:00 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ijob_inst_metric_by_job_inst import iJobInstMetricByJobInst
from bs_monitor.db.tables.job_inst_metric import tJobInstMetric

class dJobInstMetricByJobInst:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iJobInstMetricByJobInst()
        self.orec     = tJobInstMetric()

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    async def exec_deft(self,
                        jobinst_id: int,
                        limoff: str) -> "dJobInstMetricByJobInst":
        """
        Execute the query by setting all the inputs.

        :param jobinst_id: int
        :param limoff: str
        :return: Self for convenience.
        """
        self.irec.jobinst_id = jobinst_id
        self.irec.limoff = limoff

        return await self.exec()

    async def exec(self, irec: iJobInstMetricByJobInst = None) -> "dJobInstMetricByJobInst":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("JobInstMetricByJobInst", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  jm.*
from
  monitor.jobinstmetric jm
where
  jm.jobinst_id = :jobinstId
order by
  jm.stamp_tm desc
[limoff]""")

        self._dbstmnt.dynamic("[limoff]", self.irec.limoff)

        self._dbstmnt.bind_in("jobinstId", self.irec.jobinst_id, int, 8)

        self._dbstmnt.bind_out("jobinst_id", int, 8)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)
        self._dbstmnt.bind_out("mtype", str, 1)
        self._dbstmnt.bind_out("msg", str)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:JobInstMetric, proc:ByJobInst, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec.jobinst_id = self._dbstmnt.result[0]
        self.orec.stamp_tm = self._dbstmnt.result[1]
        self.orec.mtype = self._dbstmnt.result[2]
        self.orec.msg = self._dbstmnt.result[3]

        return True

    async def fetch_all(self, out_list: tJobInstMetric.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while await self.fetch():
            out_list.append(copy.deepcopy(self.orec))

        return len(out_list)

