# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:21:00 2022
#

import copy
import datetime
import uuid
import time
import dataclasses
import typing
import mettle.io
import mettle.db

@dataclasses.dataclass(slots=True)
class iBatchItemSwopId(mettle.io.ISerializable):

    batch_id: int = dataclasses.field(default=0, compare=False)
    curr_id: int = dataclasses.field(default=0, compare=False)
    new_id: int = dataclasses.field(default=0, compare=False)

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.batch_id = 0
        self.curr_id = 0
        self.new_id = 0

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'iBatchItemSwopId'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_int64("batch_id", self.batch_id)
        _w.write_int64("curr_id", self.curr_id)
        _w.write_int64("new_id", self.new_id)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.batch_id = _r.read_int64("batch_id")
        self.curr_id = _r.read_int64("curr_id")
        self.new_id = _r.read_int64("new_id")
        _r.read_end(_oname)

    def _copy_from(self, rec: "iBatchItemSwopId"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.batch_id = rec.batch_id
        self.curr_id = rec.curr_id
        self.new_id = rec.new_id

    @staticmethod
    def _cache_davs(dvc=None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("batch_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("batchId", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("currId", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("newId", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None):
        iBatchItemSwopId._cache_davs(dvc)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'iBatchItemSwopId.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = iBatchItemSwopId()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def _get_davs(self, dvc=None):
            return iBatchItemSwopId._cache_davs(dvc)

