# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:21:00 2022
#

import copy
import datetime
import uuid
import time
import dataclasses
import typing
import mettle.io
import mettle.db

@dataclasses.dataclass(slots=True)
class iJobInstSearch(mettle.io.ISerializable):

    date_from: typing.Optional[datetime.datetime] = dataclasses.field(default=None, compare=False)
    date_to: typing.Optional[datetime.datetime] = dataclasses.field(default=None, compare=False)
    criteria: str = dataclasses.field(default='', compare=False)
    limoff: str = dataclasses.field(default='', compare=False)

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.date_from = None
        self.date_to = None
        self.criteria = ''
        self.limoff = ''

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'iJobInstSearch'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_datetime("date_from", self.date_from)
        _w.write_datetime("date_to", self.date_to)
        _w.write_string("criteria", self.criteria)
        _w.write_string("limoff", self.limoff)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.date_from = _r.read_datetime("date_from")
        self.date_to = _r.read_datetime("date_to")
        self.criteria = _r.read_string("criteria")
        self.limoff = _r.read_string("limoff")
        _r.read_end(_oname)

    def _copy_from(self, rec: "iJobInstSearch"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.date_from = rec.date_from
        self.date_to = rec.date_to
        self.criteria = rec.criteria
        self.limoff = rec.limoff

    @staticmethod
    def _cache_davs(dvc=None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("dateFrom", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("dateTo", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("criteria", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("limoff", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None):
        iJobInstSearch._cache_davs(dvc)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'iJobInstSearch.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = iJobInstSearch()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def _get_davs(self, dvc=None):
            return iJobInstSearch._cache_davs(dvc)

