# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:21:00 2022
#

import copy
import datetime
import uuid
import time
import dataclasses
import typing
import mettle.io
import mettle.db

from .job_inst import tJobInst

@dataclasses.dataclass(slots=True)
class oJobInstSearch(mettle.io.ISerializable):

    inst_rec: tJobInst = dataclasses.field(default_factory=tJobInst)
    job_id: int = dataclasses.field(default=0, compare=False)
    job_name: str = dataclasses.field(default='', compare=False)
    batch_id: int = dataclasses.field(default=0, compare=False)
    batch_name: str = dataclasses.field(default='', compare=False)
    batch_cycle: str = dataclasses.field(default='', compare=False)
    batch_run_interval: int = dataclasses.field(default=0, compare=False)
    batch_run_date: typing.Optional[datetime.datetime] = dataclasses.field(default=None, compare=False)
    batchinst_id: int = dataclasses.field(default=0, compare=False)
    batchinst_run_date: typing.Optional[datetime.datetime] = dataclasses.field(default=None, compare=False)
    batchinst_status: str = dataclasses.field(default='', compare=False)

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.inst_rec.clear()
        self.job_id = 0
        self.job_name = ''
        self.batch_id = 0
        self.batch_name = ''
        self.batch_cycle = ''
        self.batch_run_interval = 0
        self.batch_run_date = None
        self.batchinst_id = 0
        self.batchinst_run_date = None
        self.batchinst_status = ''

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'oJobInstSearch'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        self.inst_rec._serialize(_w)
        _w.write_int64("job_id", self.job_id)
        _w.write_string("job_name", self.job_name)
        _w.write_int32("batch_id", self.batch_id)
        _w.write_string("batch_name", self.batch_name)
        _w.write_string("batch_cycle", self.batch_cycle)
        _w.write_int32("batch_run_interval", self.batch_run_interval)
        _w.write_datetime("batch_run_date", self.batch_run_date)
        _w.write_int64("batchinst_id", self.batchinst_id)
        _w.write_datetime("batchinst_run_date", self.batchinst_run_date)
        _w.write_char("batchinst_status", self.batchinst_status)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.inst_rec._deserialize(_r)
        self.job_id = _r.read_int64("job_id")
        self.job_name = _r.read_string("job_name")
        self.batch_id = _r.read_int32("batch_id")
        self.batch_name = _r.read_string("batch_name")
        self.batch_cycle = _r.read_string("batch_cycle")
        self.batch_run_interval = _r.read_int32("batch_run_interval")
        self.batch_run_date = _r.read_datetime("batch_run_date")
        self.batchinst_id = _r.read_int64("batchinst_id")
        self.batchinst_run_date = _r.read_datetime("batchinst_run_date")
        self.batchinst_status = _r.read_char("batchinst_status")
        _r.read_end(_oname)

    def _copy_from(self, rec: "oJobInstSearch"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.inst_rec._copy_from(rec.inst_rec)
        self.job_id = rec.job_id
        self.job_name = rec.job_name
        self.batch_id = rec.batch_id
        self.batch_name = rec.batch_name
        self.batch_cycle = rec.batch_cycle
        self.batch_run_interval = rec.batch_run_interval
        self.batch_run_date = rec.batch_run_date
        self.batchinst_id = rec.batchinst_id
        self.batchinst_run_date = rec.batchinst_run_date
        self.batchinst_status = rec.batchinst_status


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'oJobInstSearch.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = oJobInstSearch()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

